/* Copyright (c) 2001-2002 by SoftIntegration, Inc. All Rights Reserved */
#include <windows.h>
#include <cv.h>
#include <ch.h>

typedef  void* (CV_CDECL *allocFunc)(int, const char*, int);
typedef  int (CV_CDECL *freeFunc)(void**, const char*, int);

static void* allocFunc_funarg(int Arg1, const char* Arg2, int Arg3);
static void* setallocFunc_funptr;

static int freeFunc_funarg(void** Arg1, const char* Arg2, int Arg3);
static void* setfreeFunc_funptr;


EXPORTCH void cvSetMemoryManager_chdl(void *varg) {
    va_list ap;
    allocFunc allocFuncptr_ch, allocFuncptr_c=NULL;
    freeFunc freeFuncptr_ch, freeFuncptr_c=NULL;
    Ch_VaStart(ap, varg);

    allocFuncptr_ch = Ch_VaArg(ap, allocFunc );
    setallocFunc_funptr = (void *)allocFuncptr_ch;
    if (allocFuncptr_ch != NULL)  {
        allocFuncptr_c = (allocFunc)allocFunc_funarg;
    }

    freeFuncptr_ch = Ch_VaArg(ap, freeFunc);
    setfreeFunc_funptr = (void *)freeFuncptr_ch;
    if (freeFuncptr_ch != NULL)  {
        freeFuncptr_c = (freeFunc)freeFunc_funarg;
    }

    cvSetMemoryManager(allocFuncptr_c, freeFuncptr_c);
    Ch_VaEnd(ap);
}

static void*  allocFunc_funarg(int Arg1, const char* Arg2, int Arg3)    {
     void*  retval;
     Ch_CallFuncByAddr(NULL, setallocFunc_funptr, &retval, Arg1, Arg2, Arg3);
     return retval;
}

static int  freeFunc_funarg(void** Arg1, const char* Arg2, int Arg3)    {
   int retval;
   Ch_CallFuncByAddr(NULL, setfreeFunc_funptr, &retval, Arg1, Arg2, Arg3);
   return retval;
}
