/* Copyright (c) 2001-2002 by SoftIntegration, Inc. All Rights Reserved */
#include <cv.h>
#include <ch.h>

EXPORTCH CvScalar* cvAvg_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    const CvArr* mask;
    CvScalar *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    mask = Ch_VaArg(ap, const CvArr*);
    retval = (CvScalar*)malloc(sizeof(*retval));
    *retval = cvAvg(array, mask);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvRect* cvBoundingRect_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    int update;
    CvRect *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    update = Ch_VaArg(ap, int);
    retval = (CvRect*)malloc(sizeof(*retval));
    *retval = cvBoundingRect(array, update);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvBox2D* cvFitEllipse2_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    CvBox2D *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    retval = (CvBox2D*)malloc(sizeof(*retval));
    *retval = cvFitEllipse2(array);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvScalar* cvGet1D_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    int index;
    CvScalar *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    index = Ch_VaArg(ap, int);
    retval = (CvScalar*)malloc(sizeof(*retval));
    *retval = cvGet1D(array,index);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvScalar* cvGet2D_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    int index1, index2;
    CvScalar *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    index1 = Ch_VaArg(ap, int);
    index2 = Ch_VaArg(ap, int);
    retval = (CvScalar*)malloc(sizeof(*retval));
    *retval = cvGet2D(array,index1,index2);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvScalar* cvGet3D_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    int index1, index2, index3;
    CvScalar *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    index1 = Ch_VaArg(ap, int);
    index2 = Ch_VaArg(ap, int);
    index3 = Ch_VaArg(ap, int);
    retval = (CvScalar*)malloc(sizeof(*retval));
    *retval = cvGet3D(array,index1,index2,index3);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvRect* cvGetImageROI_chdl(void *varg) {
    va_list ap;
    const IplImage* array;
    CvRect *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const IplImage*);
    retval = (CvRect*)malloc(sizeof(*retval));
    *retval = cvGetImageROI(array);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvScalar* cvGetND_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    int* index;
    CvScalar *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    index = Ch_VaArg(ap, int*);
    retval = (CvScalar*)malloc(sizeof(*retval));
    *retval = cvGetND(array,index);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvSize* cvGetSize_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    CvSize *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    retval = (CvSize*)malloc(sizeof(*retval));
    *retval = cvGetSize(array);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvBox2D* cvMinAreaRect2_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    CvMemStorage* storage;
    CvBox2D *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    storage = Ch_VaArg(ap, CvMemStorage*);
    retval = (CvBox2D*)malloc(sizeof(*retval));
    *retval = cvMinAreaRect2(array, storage);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvScalar* cvSum_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    CvScalar *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    retval = (CvScalar*)malloc(sizeof(*retval));
    *retval = cvSum(array);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvScalar* cvTrace_chdl(void *varg) {
    va_list ap;
    const CvArr* array;
    CvScalar *retval;

    Ch_VaStart(ap, varg);
    array = Ch_VaArg(ap, const CvArr*);
    retval = (CvScalar*)malloc(sizeof(*retval));
    *retval = cvTrace(array);
    Ch_VaEnd(ap);
    return retval;
}

