#include <cvcam.h>
#include <ch.h>

EXPORTCH int cvcamGetCamerasCount_chdl(void *varg) {
    int retval;
    retval = cvcamGetCamerasCount();
    return retval;
}

EXPORTCH int cvcamGetProperty_chdl(void *varg) {
    va_list ap;
    int camera;
    const char* property;
    void* value;
    int retval;

    Ch_VaStart(ap, varg);
    camera = Ch_VaArg(ap, int);
    property = Ch_VaArg(ap, const char*);
    value = Ch_VaArg(ap, void*);
    retval = cvcamGetProperty(camera, property, value);
    Ch_VaEnd(ap);
    return retval;
}

/*
EXPORTCH int cvcamSetProperty_chdl(void *varg) {
    va_list ap;
    int camera;
    const char* property;
    void* value;
    int retval;

    Ch_VaStart(ap, varg);
    camera = Ch_VaArg(ap, int);
    property = Ch_VaArg(ap, const char*);
    value = Ch_VaArg(ap, void*);
    retval = cvcamSetProperty(camera, property, value);
    Ch_VaEnd(ap);
    return retval;
}

*/
EXPORTCH int cvcamGetPropertiesList_chdl(void *varg) {
    va_list ap;
    int camera;
    const char** properties;
    int count;
    int retval;

    Ch_VaStart(ap, varg);
    camera = Ch_VaArg(ap, int);
    properties = Ch_VaArg(ap, const char**);
    count = Ch_VaArg(ap, int);
    retval = cvcamGetPropertiesList(camera, properties, count);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamBuildStereo_chdl(void *varg) {
    int retval;
    retval = cvcamBuildStereo();
    return retval;
}

EXPORTCH int cvcamInit_chdl(void *varg) {
    int retval;
    retval = cvcamInit();
    return retval;
}

EXPORTCH int cvcamStart_chdl(void *varg) {
    int retval;
    retval = cvcamStart();
    return retval;
}

EXPORTCH int cvcamStop_chdl(void *varg) {
    int retval;
    retval = cvcamStop();
    return retval;
}

EXPORTCH int cvcamPause_chdl(void *varg) {
    int retval;
    retval = cvcamPause();
    return retval;
}

EXPORTCH int cvcamResume_chdl(void *varg) {
    int retval;
    retval = cvcamResume();
    return retval;
}

EXPORTCH int cvcamExit_chdl(void *varg) {
    int retval;
    retval = cvcamExit();
    return retval;
}

EXPORTCH int cvcamSelectCamera_chdl(void *varg) {
    va_list ap;
    int** out;
    int retval;

    Ch_VaStart(ap, varg);
    out = Ch_VaArg(ap, int**);
    retval = cvcamSelectCamera(out);
    Ch_VaEnd(ap);
    return retval;
}

/*
EXPORTCH int cvcamPlayAVI_chdl(void *varg) {
    va_list ap;
    const char* file;
    void* window;
    int width;
    int height;
    void* callback;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, const char*);
    window = Ch_VaArg(ap, void*);
    width = Ch_VaArg(ap, int);
    height = Ch_VaArg(ap, int);
    callback = Ch_VaArg(ap, void*);
    retval = cvcamPlayAVI(file, window, width, height, callback);
    Ch_VaEnd(ap);
    return retval;
}

*/
EXPORTCH cvcamAVIFILE cvcamAVIOpenFile_chdl(void *varg) {
    va_list ap;
    char* file;
    cvcamAVIFILE retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, char* );
    retval = cvcamAVIOpenFile(file);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamAVICloseFile_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    retval = cvcamAVICloseFile(file);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamAVISetWindow_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    void* window;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    window = Ch_VaArg(ap, void*);
    retval = cvcamAVISetWindow(file, window);
    Ch_VaEnd(ap);
    return retval;
}

/*
EXPORTCH int cvcamAVISetCallback_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    void* callback;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    callback = Ch_VaArg(ap, void*);
    retval = cvcamAVISetCallback(file, callback);
    Ch_VaEnd(ap);
    return retval;
}

*/
EXPORTCH int cvcamAVISetSize_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    int width;
    int height;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    width = Ch_VaArg(ap, int);
    height = Ch_VaArg(ap, int);
    retval = cvcamAVISetSize(file, width, height);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamAVIRun_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    retval = cvcamAVIRun(file);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamAVIStop_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    retval = cvcamAVIStop(file);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamAVIPause_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    retval = cvcamAVIPause(file);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamAVIResume_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    retval = cvcamAVIResume(file);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamAVIWaitCompletion_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    retval = cvcamAVIWaitCompletion(file);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvcamAVIIsRunning_chdl(void *varg) {
    va_list ap;
    cvcamAVIFILE file;
    int retval;

    Ch_VaStart(ap, varg);
    file = Ch_VaArg(ap, cvcamAVIFILE);
    retval = cvcamAVIIsRunning(file);
    Ch_VaEnd(ap);
    return retval;
}
