#include <highgui.h>
#include <ch.h>

EXPORTCH int cvInitSystem_chdl(void *varg) {
    va_list ap;
    int argc;
    char** argv;
    int retval;

    Ch_VaStart(ap, varg);
    argc = Ch_VaArg(ap, int);
    argv = Ch_VaArg(ap, char**);
    retval = cvInitSystem(argc, argv);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvNamedWindow_chdl(void *varg) {
    va_list ap;
    const char* name;
    int flags;
    int retval;

    Ch_VaStart(ap, varg);
    name = Ch_VaArg(ap, const char*);
    flags = Ch_VaArg(ap, int);
    retval = cvNamedWindow(name, flags);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH void cvShowImage_chdl(void *varg) {
    va_list ap;
    const char* name;
    const CvArr* image;

    Ch_VaStart(ap, varg);
    name = Ch_VaArg(ap, const char*);
    image = Ch_VaArg(ap, const CvArr*);
    cvShowImage(name, image);
    Ch_VaEnd(ap);
}

EXPORTCH void cvResizeWindow_chdl(void *varg) {
    va_list ap;
    const char* name;
    int width;
    int height;

    Ch_VaStart(ap, varg);
    name = Ch_VaArg(ap, const char*);
    width = Ch_VaArg(ap, int);
    height = Ch_VaArg(ap, int);
    cvResizeWindow(name, width, height);
    Ch_VaEnd(ap);
}

EXPORTCH void cvDestroyWindow_chdl(void *varg) {
    va_list ap;
    const char* name;

    Ch_VaStart(ap, varg);
    name = Ch_VaArg(ap, const char*);
    cvDestroyWindow(name);
    Ch_VaEnd(ap);
}

EXPORTCH void cvDestroyAllWindows_chdl(void *varg) {
    cvDestroyAllWindows();
}

EXPORTCH void* cvGetWindowHandle_chdl(void *varg) {
    va_list ap;
    const char* name;
    void* retval;

    Ch_VaStart(ap, varg);
    name = Ch_VaArg(ap, const char*);
    retval = cvGetWindowHandle(name);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH const char* cvGetWindowName_chdl(void *varg) {
    va_list ap;
    void* window_handle;
    const char* retval;

    Ch_VaStart(ap, varg);
    window_handle = Ch_VaArg(ap, void*);
    retval = cvGetWindowName(window_handle);
    Ch_VaEnd(ap);
    return retval;
}

/*
EXPORTCH int cvCreateTrackbar_chdl(void *varg) {
    va_list ap;
    const char* trackbar_name;
    const char* window_name;
    int* value;
    int count;
    CvTrackbarCallback on_change;
    int retval;

    Ch_VaStart(ap, varg);
    trackbar_name = Ch_VaArg(ap, const char*);
    window_name = Ch_VaArg(ap, const char*);
    value = Ch_VaArg(ap, int*);
    count = Ch_VaArg(ap, int);
    on_change = Ch_VaArg(ap, CvTrackbarCallback);
    retval = cvCreateTrackbar(trackbar_name, window_name, value, count, on_change);
    Ch_VaEnd(ap);
    return retval;
}

*/
EXPORTCH int cvGetTrackbarPos_chdl(void *varg) {
    va_list ap;
    const char* trackbar_name;
    const char* window_name;
    int retval;

    Ch_VaStart(ap, varg);
    trackbar_name = Ch_VaArg(ap, const char*);
    window_name = Ch_VaArg(ap, const char*);
    retval = cvGetTrackbarPos(trackbar_name, window_name);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH void cvSetTrackbarPos_chdl(void *varg) {
    va_list ap;
    const char* trackbar_name;
    const char* window_name;
    int pos;

    Ch_VaStart(ap, varg);
    trackbar_name = Ch_VaArg(ap, const char*);
    window_name = Ch_VaArg(ap, const char*);
    pos = Ch_VaArg(ap, int);
    cvSetTrackbarPos(trackbar_name, window_name, pos);
    Ch_VaEnd(ap);
}

/*
EXPORTCH void cvSetMouseCallback_chdl(void *varg) {
    va_list ap;
    const char* window_name;
    CvMouseCallback on_mouse ;

    Ch_VaStart(ap, varg);
    window_name = Ch_VaArg(ap, const char*);
    on_mouse  = Ch_VaArg(ap, CvMouseCallback);
    cvSetMouseCallback(window_name, on_mouse );
    Ch_VaEnd(ap);
}

*/
EXPORTCH IplImage* cvLoadImage_chdl(void *varg) {
    va_list ap;
    const char* filename;
    int iscolor;
    IplImage* retval;

    Ch_VaStart(ap, varg);
    filename = Ch_VaArg(ap, const char*);
    iscolor = Ch_VaArg(ap, int);
    retval = cvLoadImage(filename, iscolor);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvSaveImage_chdl(void *varg) {
    va_list ap;
    const char* filename;
    const CvArr* image;
    int retval;

    Ch_VaStart(ap, varg);
    filename = Ch_VaArg(ap, const char*);
    image = Ch_VaArg(ap, const CvArr*);
    retval = cvSaveImage(filename, image);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH void cvAddSearchPath_chdl(void *varg) {
    va_list ap;
    const char* path ;

    Ch_VaStart(ap, varg);
    path  = Ch_VaArg(ap, const char*);
    cvAddSearchPath(path );
    Ch_VaEnd(ap);
}

EXPORTCH void cvConvertImage_chdl(void *varg) {
    va_list ap;
    const CvArr* src;
    CvArr* dst;
    int flip;

    Ch_VaStart(ap, varg);
    src = Ch_VaArg(ap, const CvArr*);
    dst = Ch_VaArg(ap, CvArr*);
    flip = Ch_VaArg(ap, int);
    cvConvertImage(src, dst, flip);
    Ch_VaEnd(ap);
}

EXPORTCH int cvWaitKey_chdl(void *varg) {
    va_list ap;
    int delay;
    int retval;

    Ch_VaStart(ap, varg);
    delay = Ch_VaArg(ap, int);
    retval = cvWaitKey(delay);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvCapture* cvCaptureFromAVI_chdl(void *varg) {
    va_list ap;
    const char* filename;
    CvCapture* retval;

    Ch_VaStart(ap, varg);
    filename = Ch_VaArg(ap, const char*);
    retval = cvCaptureFromAVI(filename);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvCapture* cvCaptureFromCAM_chdl(void *varg) {
    va_list ap;
    int index ;
    CvCapture* retval;

    Ch_VaStart(ap, varg);
    index  = Ch_VaArg(ap, int);
    retval = cvCaptureFromCAM(index );
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvGrabFrame_chdl(void *varg) {
    va_list ap;
    CvCapture* capture;
    int retval;

    Ch_VaStart(ap, varg);
    capture = Ch_VaArg(ap, CvCapture*);
    retval = cvGrabFrame(capture);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH IplImage* cvRetrieveFrame_chdl(void *varg) {
    va_list ap;
    CvCapture* capture;
    IplImage* retval;

    Ch_VaStart(ap, varg);
    capture = Ch_VaArg(ap, CvCapture*);
    retval = cvRetrieveFrame(capture);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH IplImage* cvQueryFrame_chdl(void *varg) {
    va_list ap;
    CvCapture* capture;
    IplImage* retval;

    Ch_VaStart(ap, varg);
    capture = Ch_VaArg(ap, CvCapture*);
    retval = cvQueryFrame(capture);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH void cvReleaseCapture_chdl(void *varg) {
    va_list ap;
    CvCapture** capture;

    Ch_VaStart(ap, varg);
    capture = Ch_VaArg(ap, CvCapture**);
    cvReleaseCapture(capture);
    Ch_VaEnd(ap);
}

EXPORTCH double cvGetCaptureProperty_chdl(void *varg) {
    va_list ap;
    CvCapture* capture;
    int property_id;
    double retval;

    Ch_VaStart(ap, varg);
    capture = Ch_VaArg(ap, CvCapture*);
    property_id = Ch_VaArg(ap, int);
    retval = cvGetCaptureProperty(capture, property_id);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvSetCaptureProperty_chdl(void *varg) {
    va_list ap;
    CvCapture* capture;
    int property_id;
    double value;
    int retval;

    Ch_VaStart(ap, varg);
    capture = Ch_VaArg(ap, CvCapture*);
    property_id = Ch_VaArg(ap, int);
    value = Ch_VaArg(ap, double);
    retval = cvSetCaptureProperty(capture, property_id, value);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH CvAVIWriter* cvCreateAVIWriter_chdl(void *varg) {
    va_list ap;
    const char* filename;
    int fourcc;
    double fps;
    CvSize frameSize;
    CvAVIWriter* retval;

    Ch_VaStart(ap, varg);
    filename = Ch_VaArg(ap, const char*);
    fourcc = Ch_VaArg(ap, int);
    fps = Ch_VaArg(ap, double);
    frameSize = Ch_VaArg(ap, CvSize);
    retval = cvCreateAVIWriter(filename, fourcc, fps, frameSize);
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH int cvWriteToAVI_chdl(void *varg) {
    va_list ap;
    CvAVIWriter* writer;
    const IplImage* image ;
    int retval;

    Ch_VaStart(ap, varg);
    writer = Ch_VaArg(ap, CvAVIWriter*);
    image  = Ch_VaArg(ap, const IplImage*);
    retval = cvWriteToAVI(writer, image );
    Ch_VaEnd(ap);
    return retval;
}

EXPORTCH void cvReleaseAVIWriter_chdl(void *varg) {
    va_list ap;
    CvAVIWriter** writer;

    Ch_VaStart(ap, varg);
    writer = Ch_VaArg(ap, CvAVIWriter**);
    cvReleaseAVIWriter(writer);
    Ch_VaEnd(ap);
}

/*
EXPORTCH void set_preprocess_func_chdl(void *varg) {
    va_list ap;
    CvWin32WindowCallback on_preprocess;

    Ch_VaStart(ap, varg);
    on_preprocess = Ch_VaArg(ap, CvWin32WindowCallback);
    set_preprocess_func(on_preprocess);
    Ch_VaEnd(ap);
}

*/
/*
EXPORTCH void set_postprocess_func_chdl(void *varg) {
    va_list ap;
    CvWin32WindowCallback on_postprocess;

    Ch_VaStart(ap, varg);
    on_postprocess = Ch_VaArg(ap, CvWin32WindowCallback);
    set_postprocess_func(on_postprocess);
    Ch_VaEnd(ap);
}
*/
