#!/bin/ch
#include <unistd.h>
if(access("update_ch.ch", R_OK)) {
    echo Run me from OPENCV_HOME/interfaces/ch/Devel
    exit(-1);
}

echo copying headers ...
mkdir ..\OpenCV 2>nul
mkdir ..\OpenCV\include 2>nul
copy  /Y ..\..\..\cv\include\cv*.h ..\OpenCV\include
copy  /Y ..\..\..\otherlibs\highgui\highgui.h ..\OpenCV\include
copy  /Y ..\..\..\otherlibs\cvcam\include\cvcam.h ..\OpenCV\include
//sed -e  "s/array/array_c/g" ..\..\..\cv\include\cv.h > ..\OpenCV\include\cv.h
//sed -e  "s/array/array_c/g" ..\..\..\otherlibs\cvcam\include\cvcam.h > ..\OpenCV\include\cvcam.h

echo updating function lists
mkdir .\createchf 2> nul

processhfile("OPENCVAPI", 0, ";",  "../OpenCV/include/cv.h", 
"./createchf/cv.h", "CV_DEFAULT");
processhfile("HIGHGUI_API", 0, ";", "../OpenCV/include/highgui.h", 
"./createchf/highgui.h", "CV_DEFAULT");
processhfile("CVCAM_API", 0, ";", "../OpenCV/include/cvcam.h", 
"./createchf/cvcam.h", "CV_DEFAULT");

echo generating *.chf and xxx_chdl.c files
cd createchf
c2chf cv.h 2>nul >nul
attrib -R cv\*.*
mkdir ..\..\OpenCV\lib 2> nul
move /Y cv\*.chf ..\..\OpenCV\lib
move /Y cv\cv_chdl.c ..\c\cv
rmdir("cv");

c2chf highgui.h 2>nul >nul
attrib -R highgui\*.*
move /Y highgui\*.chf ..\..\OpenCV\lib
move /Y highgui\highgui_chdl.c ..\c\highgui
rmdir("highgui");

c2chf cvcam.h 2>nul >nul
attrib -R cvcam\*.*
move /Y cvcam\*.chf ..\..\OpenCV\lib
move /Y cvcam\cvcam_chdl.c ..\c\cvcam
rmdir("cvcam");


cd ..

echo patching certain .chf files
copy /Y lib.handmade\*.chf ..\OpenCV\lib

echo removing duplicants 
processcfile("c/cv", "cv_chdl.c");
processcfile("c/highgui", "highgui_chdl.c");
processcfile("c/cvcam", "cvcam_chdl.c");

echo making .dl files
cd c\cv
del /Q *.dl *.obj *.exp *.lib 2>nul
nmake /f Makefile >nul 2>nul
del /Q *.obj *.exp *.lib

cd ..\highgui
del /Q *.dl *.obj *.exp *.lib 2>nul
nmake /f Makefile >nul 2>nul
del /Q *.obj *.exp *.lib

cd ..\cvcam
del /Q *.dl *.obj *.exp *.lib 2>nul
nmake /f Makefile >nul 2>nul
del /Q *.obj *.exp *.lib

cd ..\..
mkdir ..\OpenCV\dl 2>nul >nul
move /Y c\cv\libcv.dl ..\OpenCV\dl
move /Y c\highgui\libhighgui.dl ..\OpenCV\dl
move /Y c\cvcam\libcvcam.dl ..\OpenCV\dl

echo copying OpenCV DLLs
mkdir ..\OpenCV\bin 2>nul >nul
copy /Y ..\..\..\bin\cv.dll ..\OpenCV\bin
copy /Y ..\..\..\bin\highgui.dll ..\OpenCV\bin
copy /Y ..\..\..\bin\cvcam.dll ..\OpenCV\bin

echo copying samples
mkdir ..\OpenCV\demos 2>nul >nul
copy /Y demos\demhist.ch  ..\OpenCV\demos
copy /Y ..\..\..\samples\c\*.* ..\OpenCV\demos

